<template>
  <div class="container">
    <Breadcrumb :items="['充值账户管理', '京东Cookie']" />
    <a-card class="general-card" title="京东Cookie管理">
      <a-row>
        <a-col :flex="1">
          <a-form
            :model="formModel"
            :label-col-props="{ span: 6 }"
            :wrapper-col-props="{ span: 18 }"
            label-align="left"
          >
            <a-row :gutter="16">
              <a-col :span="8">
                <a-form-item field="cookie" label="cookie">
                  <a-input
                    v-model="formModel.cookie"
                    placeholder="请输入Cookie"
                  />
                </a-form-item>
              </a-col>
              <a-col :span="8">
                <a-form-item field="name" label="名称">
                  <a-input v-model="formModel.name" placeholder="请输入名称" />
                </a-form-item>
              </a-col>
              <a-col :span="8">
                <a-form-item field="nickname" label="京东昵称">
                  <a-input
                    v-model="formModel.nickname"
                    placeholder="请输入京东账户昵称"
                  />
                </a-form-item>
              </a-col>
            </a-row>
          </a-form>
        </a-col>
        <a-divider style="height: 42px" direction="vertical" />
        <a-col flex="172px" style="text-align: right">
          <a-space direction="horizontal" :size="18">
            <a-button type="primary" @click="search">
              <template #icon>
                <icon-search />
              </template>
              搜索
            </a-button>
            <a-button @click="reset">
              <template #icon>
                <icon-refresh />
              </template>
              重置
            </a-button>
          </a-space>
        </a-col>
      </a-row>
      <a-divider style="margin-top: 0" />
      <a-row style="margin-bottom: 16px">
        <a-space>
          <a-button
            v-if="checkTokenFromLogin()"
            type="primary"
            size="small"
            @click="showAddModel({ id: '', ...generateFormModel() })"
          >
            <template #icon>
              <icon-plus />
            </template>
            添加
          </a-button>
          <a-button @click="download">
            <template #icon>
              <icon-download />
            </template>
            导出
          </a-button>
          <batchImportModel @close="() => search()" />
        </a-space>
      </a-row>
      <a-table
        :loading="loading"
        :pagination="{
          current: pagination.current,
          pageSize: pagination.pageSize,
          total: pagination.total,
          pageSizeOptions: [10, 20, 50, 100],
          showPageSize: true
        }"
        :columns="columns"
        :data="renderData"
        :scroll="{ x: 1080 }"
        @page-change="onPageChange"
        @page-size-change="onPageSizeChange"
      >
        <template #status="{ record }">
          <a-space size="small">
            <a-switch
              v-if="[0, 1].includes(record.status)"
              v-model="record.status"
              size="small"
              :checked-value="1"
              :unchecked-value="0"
              :beforeChange="newValue => updateCurrentStatus(record, newValue)"
            />
            <a-tag
              v-else
              size="small"
              :color="statusMapper(record.status).color"
            >
              {{ statusMapper(record.status).text }}
            </a-tag>
          </a-space>
        </template>
        <template #operations="{ record }">
          <a-space size="small">
            <a-tooltip content="修改">
              <a-button
                size="small"
                status="warning"
                @click="showAddModel(record)"
              >
                <template #icon>
                  <icon-pen />
                </template>
              </a-button>
            </a-tooltip>
            <a-tooltip content="详情">
              <a-button size="small" @click="showDetailModel(record)">
                <template #icon>
                  <icon-list />
                </template>
              </a-button>
            </a-tooltip>
            <a-popconfirm
              type="warning"
              content="确认刷新账号状态嘛？"
              @ok="refreshButton(record)"
            >
              <a-tooltip content="刷新">
                <a-button
                  v-if="record.status === 3"
                  size="small"
                  status="success"
                >
                  <template #icon>
                    <icon-refresh />
                  </template>
                </a-button>
              </a-tooltip>
            </a-popconfirm>
            <a-tooltip content="删除">
              <a-button
                v-if="checkTokenFromIframe()"
                size="small"
                status="danger"
                @click="deleteOne(record.id)"
              >
                <template #icon>
                  <icon-delete />
                </template>
              </a-button>
            </a-tooltip>
          </a-space>
        </template>
      </a-table>
    </a-card>
    <add-modal
      :id="state.accountId"
      v-model:visible="state.addModalVisible"
      :account="state.account"
    />
    <account-detail
      v-model:visible="state.accountDetailVisible"
      :accountId="state.accountId"
    />
  </div>
</template>

<script lang="ts" setup>
import useLoading from '@/hooks/loading';
import { Pagination } from '@/types/global';
import { checkTokenFromIframe, checkTokenFromLogin } from '@/utils/auth';
import { onMounted, reactive, ref, watchEffect } from 'vue';
import { Notification, TableColumnData } from '@arco-design/web-vue';
import AddModal from './components/add-modal.vue';
import AccountDetail from './components/detail.vue';
import { batchImportModel } from './components/component.tsx';
import {
  ApiCardInfoJDCardAccountGetListGetPageSizeEnum,
  KamiApiCardInfoJdV1JDAccountListRecord,
  KamiApiCardInfoJdV1JDAccountUpdateStatusReqStatusEnum
} from '@/api/generated/index.ts';
import { apiClient } from '@/api/index.ts';
import { downloadDataList, JDCardParams } from '@/api/card-jd-account.ts';

const basePagination: Pagination = {
  current: 1,
  pageSize: 50
};
const pagination = reactive({
  ...basePagination
});
const columns: TableColumnData[] = [
  {
    title: '序号',
    dataIndex: 'index',
    render: ({ rowIndex }) => {
      return rowIndex + 1 + (pagination.current - 1) * pagination.pageSize;
    }
  },
  {
    title: '名称',
    dataIndex: 'name'
  },
  {
    title: '昵称',
    dataIndex: 'nickname'
  },
  {
    title: '余额',
    dataIndex: 'balance'
  },
  {
    title: '今日充值金额',
    dataIndex: 'amountTodaySum'
  },
  {
    title: '今日充值次数',
    dataIndex: 'amountTodayCount'
  },
  {
    title: '充值限制',
    dataIndex: 'maxAmountLimit'
  },
  {
    title: '累计充值金额',
    dataIndex: 'amountTotalSum'
  },
  {
    title: '累计充值次数',
    dataIndex: 'amountTotalCount'
  },
  {
    title: 'ck',
    dataIndex: 'cookie',
    ellipsis: true,
    tooltip: true
  },
  {
    title: '创建人',
    dataIndex: 'uploadUser.username'
  },
  {
    title: '状态',
    dataIndex: 'status',
    slotName: 'status'
  },
  {
    title: '创建时间',
    dataIndex: 'createdAt',
    slotName: 'createdAt'
  },
  {
    title: '操作',
    dataIndex: 'operations',
    slotName: 'operations',
    fixed: 'right',
    width: 220
  }
];
const generateFormModel = () => {
  return {
    remark: '',
    name: '',
    cookie: '',
    nickname: '',
    maxAmountLimit: 0,
    status: 1
  };
};
const { loading, setLoading } = useLoading(true);
const renderData = ref<KamiApiCardInfoJdV1JDAccountListRecord[]>([]);
const formModel = ref(generateFormModel());
const state = reactive({
  addModalVisible: false,
  deployModalVisible: false,
  accountDetailVisible: false,
  accountId: '',
  account: null
});

const fetchData = async (
  params: JDCardParams = { current: 1, pageSize: 50 }
) => {
  setLoading(true);
  try {
    const {
      data: { list, total }
    } = await apiClient.apiCardInfoJDCardAccountGetListGet({
      current: params.current,
      pageSize:
        params.pageSize as unknown as ApiCardInfoJDCardAccountGetListGetPageSizeEnum,
      name: params.name,
      nickName: params.nickname,
      cookie: params.cookie
    });
    renderData.value = list;
    pagination.current = params.current;
    pagination.pageSize = params.pageSize;
    pagination.total = total;
  } catch (err) {
    // you can report use errorHandler or other
  } finally {
    setLoading(false);
  }
};
const onPageChange = (current: number) => {
  fetchData({ ...pagination, current });
};
const onPageSizeChange = (pageSize: number) => {
  fetchData({ ...pagination, pageSize });
};
const search = () => {
  fetchData({
    ...basePagination,
    ...formModel.value
  } as unknown as JDCardParams);
};
const reset = () => {
  formModel.value = generateFormModel();
};

const deleteOne = async (id: string) => {
  try {
    await apiClient.apiCardInfoJDCardAccountDeleteDelete({
      id: id
    });
  } catch {
    Notification.error({
      id: 'JDAccountNotice',
      content: '删除京东卡失败',
      closable: true
    });
  } finally {
    fetchData({ ...pagination });
  }
};

const showAddModel = (record: KamiApiCardInfoJdV1JDAccountListRecord) => {
  state.addModalVisible = true;
  state.accountId = record.id;
  state.account = record;
};
const showDetailModel = (record: KamiApiCardInfoJdV1JDAccountListRecord) => {
  state.accountDetailVisible = true;
  state.accountId = record.id;
};
watchEffect(() => {
  // 目标账户和存储用户不能相同
  if (!state.addModalVisible) {
    search();
  }
});
const updateCurrentStatus = async (
  record: KamiApiCardInfoJdV1JDAccountListRecord,
  newValue: string | number | boolean
) => {
  await apiClient.apiCardInfoJDCardAccountUpdateStatusPut({
    kamiApiCardInfoJdV1JDAccountUpdateStatusReq: {
      id: record.id,
      status: newValue as KamiApiCardInfoJdV1JDAccountUpdateStatusReqStatusEnum
    }
  });
  record.status = newValue as number;
};

const statusMapper = (status: number): { text: string; color: string } => {
  switch (status) {
    case 0:
      return { text: '失效', color: 'red' };
    case 1:
      return { text: '正常', color: 'green' };
    case 2:
      return { text: '充值过快', color: 'orange' };
    case 3:
      return { text: '充值限制(用户设置)', color: 'red' };
    case 4:
      return { text: '充值限制(其他)', color: 'red' };
    case 5:
      return { text: '充值限制(低额)', color: 'red' };
    case 6:
      return { text: '充值限制(安全原因)', color: 'red' };
    case 7:
      return { text: '充值限制(暂时限制)', color: 'red' };
    case 8:
      return { text: '充值限制(平台原因)', color: 'red' };
    default:
      return { text: '未知', color: 'gray' };
  }
};
const refreshButton = (record: KamiApiCardInfoJdV1JDAccountListRecord) => {
  apiClient
    .apiCardInfoJDCardAccountRefreshStatusPut({
      kamiApiCardInfoJdV1JDAccountRefreshStatusReq: {
        id: record.id
      }
    })
    .then(() => {
      fetchData();
    });
};
onMounted(() => {
  fetchData();
});
const download = () => {
  downloadDataList();
};
</script>
